diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCacao.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCacao.java
index 632036c09..69e9a846d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCacao.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCacao.java
@@ -5,21 +5,21 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLeavesCacao;
-import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicLeavesCacao;
 import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelLeavesCacao<T extends Block> extends BlockModelLeaves<T> {
+public class BlockModelLeavesCacao<T extends BlockLogic> extends BlockModelLeaves<T> {
     protected IconCoordinate[] growthStages = new IconCoordinate[]{
             TextureRegistry.getTexture("minecraft:block/leaves/cacao_bean_stage0"),
             TextureRegistry.getTexture("minecraft:block/leaves/cacao_bean_stage1"),
             TextureRegistry.getTexture("minecraft:block/leaves/cacao_bean_stage2"),
             TextureRegistry.getTexture("minecraft:block/leaves/cacao_bean_stage3")};
-    public BlockModelLeavesCacao(Block block) {
+    public BlockModelLeavesCacao(Block<T> block) {
         super(block, "minecraft:block/leaves/cacao");
-        assert growthStages.length == BlockLeavesCacao.MAX_GROWTH_STATE : "There must be a texture associated with every cacao bean stage!";
+        assert growthStages.length == BlockLogicLeavesCacao.MAX_GROWTH_STATE : "There must be a texture associated with every cacao bean stage!";
     }
 
     @Override
@@ -28,17 +28,17 @@ public class BlockModelLeavesCacao<T extends Block> extends BlockModelLeaves<T>
 
         AABB bounds = block.getBounds();
 
-        final int growthRate = BlockLeavesCacao.getGrowthRate(renderBlocks.blockAccess.getBlockMetadata(x, y, z));
+        final int growthRate = BlockLogicLeavesCacao.getGrowthRate(renderBlocks.blockAccess.getBlockMetadata(x, y, z));
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
             int lmc = block.getLightmapCoord(renderBlocks.blockAccess, x, y, z);
-            if(Blocks.lightEmission[block.id] > 0) {
+            if(block.emission > 0) {
                 lmc = LightmapHelper.setBlocklightValue(lmc, 15);
             }
             tessellator.setLightmapCoord(lmc);
         }else {
             brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
-            if(Blocks.lightEmission[block.id] > 0) {
+            if(block.emission > 0) {
                 brightness = 1.0f;
             }
         }
@@ -46,7 +46,7 @@ public class BlockModelLeavesCacao<T extends Block> extends BlockModelLeaves<T>
         final float cNorthSouth = 0.8F;
         final float cEastWest = 0.6F;
         if (growthRate > 0) {
-            renderBlocks.overrideBlockTexture = growthStages[Math.min(growthRate - 1, BlockLeavesCacao.MAX_GROWTH_STATE - 1)];
+            renderBlocks.overrideBlockTexture = growthStages[Math.min(growthRate - 1, BlockLogicLeavesCacao.MAX_GROWTH_STATE - 1)];
             tessellator.setColorOpaque_F(cNorthSouth * brightness, cNorthSouth * brightness, cNorthSouth * brightness);
             renderNorthFace(tessellator, bounds, x, y, z, renderBlocks.overrideBlockTexture);
             renderSouthFace(tessellator, bounds, x, y, z, renderBlocks.overrideBlockTexture);
@@ -65,7 +65,7 @@ public class BlockModelLeavesCacao<T extends Block> extends BlockModelLeaves<T>
 
         AABB bounds = block.getBounds();
 
-        final IconCoordinate cacaoCoord = growthStages[BlockLeavesCacao.MAX_GROWTH_STATE - 1];
+        final IconCoordinate cacaoCoord = growthStages[BlockLogicLeavesCacao.MAX_GROWTH_STATE - 1];
         GL11.glColor4f(brightness, brightness, brightness, alpha);
 
         tessellator.startDrawingQuads();
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCherryFlowering.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCherryFlowering.java
index ecfd2f639..fbd3b8034 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCherryFlowering.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCherryFlowering.java
@@ -4,15 +4,16 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLeavesCherryFlowering;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicLeavesCherryFlowering;
 import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelLeavesCherryFlowering<T extends Block> extends BlockModelLeaves<T> {
+public class BlockModelLeavesCherryFlowering<T extends BlockLogic> extends BlockModelLeaves<T> {
     private final IconCoordinate grownCherryOverlay = TextureRegistry.getTexture("minecraft:block/leaves/cherry_overlay");
     private final IconCoordinate floweringCherryOverlay = TextureRegistry.getTexture("minecraft:block/leaves/cherry_flowering_overlay");
-    public BlockModelLeavesCherryFlowering(Block block) {
+    public BlockModelLeavesCherryFlowering(Block<T> block) {
         super(block, "minecraft:block/leaves/cherry");
     }
 
@@ -20,7 +21,7 @@ public class BlockModelLeavesCherryFlowering<T extends Block> extends BlockModel
     public boolean render(Tessellator tessellator, int x, int y, int z) {
         super.render(tessellator, x, y, z);
 
-        int growthRate = BlockLeavesCherryFlowering.getGrowthRate(renderBlocks.blockAccess.getBlockMetadata(x, y, z));
+        int growthRate = BlockLogicLeavesCherryFlowering.getGrowthRate(renderBlocks.blockAccess.getBlockMetadata(x, y, z));
         if(growthRate > 0) {
             renderBlocks.overrideBlockTexture = grownCherryOverlay;
         } else {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
index 9c6035792..4d8f54e4f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
@@ -4,15 +4,16 @@ import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLever;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicLever;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.Vec3;
 
-public class BlockModelLever<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelLever(Block block) {
+public class BlockModelLever<T extends BlockLogic> extends BlockModelStandard<T> {
+    public BlockModelLever(Block<T> block) {
         super(block);
     }
 
@@ -31,28 +32,28 @@ public class BlockModelLever<T extends Block> extends BlockModelStandard<T> {
         float f2 = 0.1875F;
         AABB bounds = block.getBounds();
         switch (i1) {
-            case BlockLever.ROTATION_BOTTOM_NS:
+            case BlockLogicLever.ROTATION_BOTTOM_NS:
                 bounds.set(0.5F - f1, 1f - f2, 0.5F - f, 0.5F + f1, 1f, 0.5F + f);
                 break;
-            case BlockLever.ROTATION_BOTTOM_WE:
+            case BlockLogicLever.ROTATION_BOTTOM_WE:
                 bounds.set(0.5F - f, 1f - f2, 0.5F - f1, 0.5F + f, 1f, 0.5F + f1);
                 break;
-            case BlockLever.ROTATION_TOP_NS:
+            case BlockLogicLever.ROTATION_TOP_NS:
                 bounds.set(0.5F - f1, 0.0F, 0.5F - f, 0.5F + f1, f2, 0.5F + f);
                 break;
-            case BlockLever.ROTATION_TOP_WE:
+            case BlockLogicLever.ROTATION_TOP_WE:
                 bounds.set(0.5F - f, 0.0F, 0.5F - f1, 0.5F + f, f2, 0.5F + f1);
                 break;
-            case BlockLever.ROTATION_NORTH:
+            case BlockLogicLever.ROTATION_NORTH:
                 bounds.set(0.5F - f1, 0.5F - f, 1.0F - f2, 0.5F + f1, 0.5F + f, 1.0F);
                 break;
-            case BlockLever.ROTATION_SOUTH:
+            case BlockLogicLever.ROTATION_SOUTH:
                 bounds.set(0.5F - f1, 0.5F - f, 0.0F, 0.5F + f1, 0.5F + f, f2);
                 break;
-            case BlockLever.ROTATION_WEST:
+            case BlockLogicLever.ROTATION_WEST:
                 bounds.set(1.0F - f2, 0.5F - f, 0.5F - f1, 1.0F, 0.5F + f, 0.5F + f1);
                 break;
-            case BlockLever.ROTATION_EAST:
+            case BlockLogicLever.ROTATION_EAST:
                 bounds.set(0.0F, 0.5F - f, 0.5F - f1, f2, 0.5F + f, 0.5F + f1);
                 break;
         }
@@ -65,7 +66,7 @@ public class BlockModelLever<T extends Block> extends BlockModelStandard<T> {
         if(LightmapHelper.isLightmapEnabled()) {
         	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
         }else {
-			if(Blocks.lightEmission[block.id] > 0) {
+			if(block.emission > 0) {
 				brightness = 1.0f;
 			}else {
 				brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelMotionSensor.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelMotionSensor.java
index 377ca0d5a..47ac3ca0f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelMotionSensor.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelMotionSensor.java
@@ -3,22 +3,22 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFullyRotatable;
-import net.minecraft.core.block.BlockMotionSensor;
+import net.minecraft.core.block.BlockLogicVeryRotatable;
+import net.minecraft.core.block.BlockLogicMotionSensor;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelMotionSensor extends BlockModelVeryRotatable<BlockMotionSensor> {
+public class BlockModelMotionSensor extends BlockModelVeryRotatable<BlockLogicMotionSensor> {
     protected IconCoordinate overlay = TextureRegistry.getTexture("minecraft:block/motion_sensor/active_front_overlay");
-    public BlockModelMotionSensor(Block block) {
+    public BlockModelMotionSensor(Block<BlockLogicMotionSensor> block) {
         super(block);
     }
 
     @Override
     public IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data)
     {
-        if (!block.isActive) return null;
+        if (!block.getLogic().isActive) return null;
 
-        if(side.getId() == BlockFullyRotatable.metaToDirection(data).getSide().getId())
+        if(side.getId() == BlockLogicVeryRotatable.metaToDirection(data).getSide().getId())
         {
             return overlay;
         }
@@ -26,6 +26,6 @@ public class BlockModelMotionSensor extends BlockModelVeryRotatable<BlockMotionS
     }
     @Override
     public boolean hasOverbright(){
-        return block.isActive;
+        return block.getLogic().isActive;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelOverlayLeaves.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelOverlayLeaves.java
index fffb510a0..ab891b458 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelOverlayLeaves.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelOverlayLeaves.java
@@ -4,13 +4,14 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelOverlayLeaves<T extends Block> extends BlockModelLeaves<T> {
+public class BlockModelOverlayLeaves<T extends BlockLogic> extends BlockModelLeaves<T> {
     protected final IconCoordinate overlayTexture;
-    public BlockModelOverlayLeaves(Block block, String leavesTex, String overlayTex) {
+    public BlockModelOverlayLeaves(Block<T> block, String leavesTex, String overlayTex) {
         super(block, leavesTex);
         overlayTexture = TextureRegistry.getTexture(overlayTex);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java
index a8468b87d..1181804e2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java
@@ -5,16 +5,17 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelPebbles<T extends Block> extends BlockModelStandard<T> {
+public class BlockModelPebbles<T extends BlockLogic> extends BlockModelStandard<T> {
     protected IconCoordinate[] pebbles = {
             TextureRegistry.getTexture("minecraft:block/pebbles/0"),
             TextureRegistry.getTexture("minecraft:block/pebbles/1"),
             TextureRegistry.getTexture("minecraft:block/pebbles/2")
     };
-    public BlockModelPebbles(Block block) {
+    public BlockModelPebbles(Block<T> block) {
         super(block);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiePumpkin.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiePumpkin.java
index ec7abc70d..88fa02e4c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiePumpkin.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiePumpkin.java
@@ -4,16 +4,16 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockEdible;
+import net.minecraft.core.block.BlockLogicEdible;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 
-public class BlockModelPiePumpkin<T extends BlockEdible> extends BlockModelStandard<T> {
+public class BlockModelPiePumpkin<T extends BlockLogicEdible> extends BlockModelStandard<T> {
     protected IconCoordinate sideTexture = TextureRegistry.getTexture("minecraft:block/pumpkin_pie/side");
     protected IconCoordinate insideTexture = TextureRegistry.getTexture("minecraft:block/pumpkin_pie/inner");
     protected IconCoordinate topTexture = TextureRegistry.getTexture("minecraft:block/pumpkin_pie/top");
 
-    public BlockModelPiePumpkin(Block block) {
+    public BlockModelPiePumpkin(Block<T> block) {
         super(block);
         float f = 0.0625F;
         float f1 = 0.375F;
@@ -48,7 +48,7 @@ public class BlockModelPiePumpkin<T extends BlockEdible> extends BlockModelStand
         boolean insideEast = sliceX == 0 ;
         boolean insideWest = sliceX == 1;
 
-        maxSlices = block.maxBites;
+        maxSlices = block.getLogic().maxBites;
         bounds.set(xMin + offsetXMin, 0.0F, zMin + offsetZMin, xMax - offsetXMax, 0.375F, zMax - offsetZMax);
         renderSide(tessellator, bounds, x, y, z, Side.TOP, 0);
         renderSide(tessellator, bounds, x, y, z, Side.BOTTOM, 0);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
index ceb16c3ee..0ae4bffe9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
@@ -4,24 +4,24 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.piston.BlockPistonBase;
+import net.minecraft.core.block.piston.BlockLogicPistonBase;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockModelPiston<T extends BlockPistonBase> extends BlockModelStandard<T> {
+public class BlockModelPiston<T extends BlockLogicPistonBase> extends BlockModelStandard<T> {
     private final IconCoordinate faceTexture;
     protected IconCoordinate sideTexture = TextureRegistry.getTexture("minecraft:block/piston/side");
     protected IconCoordinate topTexture = TextureRegistry.getTexture("minecraft:block/piston/top");
     protected IconCoordinate bottomTexture = TextureRegistry.getTexture("minecraft:block/piston/bottom");
 
     protected final double headThickness;
-    public BlockModelPiston(Block block, IconCoordinate faceTexture){
+    public BlockModelPiston(Block<T> block, IconCoordinate faceTexture){
         this(block, faceTexture, 4/16d);
     }
 
-    public BlockModelPiston(Block block, IconCoordinate faceTexture, double headThickness){
+    public BlockModelPiston(Block<T> block, IconCoordinate faceTexture, double headThickness){
         super(block);
         this.headThickness = headThickness;
         this.faceTexture = faceTexture;
@@ -43,16 +43,19 @@ public class BlockModelPiston<T extends BlockPistonBase> extends BlockModelStand
         return renderPistonBase(tessellator, x, y, z, false);
     }
 
+    private boolean headless = false;
     public boolean renderHeadless(Tessellator tessellator, int x, int y, int z) {
         renderBlocks.renderAllFaces = true;
+        headless = true;
         boolean result = renderPistonBase(tessellator, x, y, z, true);
+        headless = false;
         renderBlocks.renderAllFaces = false;
         return result;
     }
     protected boolean renderPistonBase(Tessellator tessellator, int x, int y, int z, boolean noCulling) {
         int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         boolean extended = noCulling || (meta & 8) != 0;
-        Direction direction = BlockPistonBase.getDirection(meta);
+        Direction direction = BlockLogicPistonBase.getDirection(meta);
         AABB bounds;
         if(extended)
         {
@@ -159,15 +162,14 @@ public class BlockModelPiston<T extends BlockPistonBase> extends BlockModelStand
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
-        AABB bounds = block.getBounds();
-        Direction direction = BlockPistonBase.getDirection(data);
+        Direction direction = BlockLogicPistonBase.getDirection(data);
         if (direction == Direction.NONE)
         {
             return atlasIndices[0];
         }
         if (side.getDirection() == direction)
         {
-            if (BlockPistonBase.isPowered(data) || bounds.minX > 0.0D || bounds.minY > 0.0D || bounds.minZ > 0.0D || bounds.maxX < 1.0D || bounds.maxY < 1.0D || bounds.maxZ < 1.0D)
+            if (BlockLogicPistonBase.isPowered(data) || headless)
             {
                 return topTexture;
             }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
index 8544629b5..7a18fc5e2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
@@ -6,13 +6,13 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.piston.BlockPistonHead;
+import net.minecraft.core.block.piston.BlockLogicPistonHead;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockModelPistonHead extends BlockModelStandard<BlockPistonHead> {
+public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHead> {
     protected IconCoordinate pistonSide;
     protected IconCoordinate pistonDry = TextureRegistry.getTexture("minecraft:block/piston/face");
     protected IconCoordinate pistonSticky = TextureRegistry.getTexture("minecraft:block/piston_sticky/face");
@@ -21,11 +21,11 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockPistonHead> {
     public IconCoordinate faceTextureOverride;
 
     protected final double headThickness;
-    public BlockModelPistonHead(Block block, IconCoordinate pistonSide) {
+    public BlockModelPistonHead(Block<BlockLogicPistonHead> block, IconCoordinate pistonSide) {
         this(block, pistonSide, 4/16d);
     }
 
-    public BlockModelPistonHead(Block block, IconCoordinate pistonSide, double headThickness) {
+    public BlockModelPistonHead(Block<BlockLogicPistonHead> block, IconCoordinate pistonSide, double headThickness) {
         super(block);
         this.pistonSide = pistonSide;
         this.headThickness = headThickness;
@@ -35,7 +35,7 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockPistonHead> {
     public boolean render(Tessellator tessellator, int x, int y, int z) {
         return renderPistonHead(tessellator, block, x, y, z, true);
     }
-    public void renderPistonHeadNoCulling(Tessellator tessellator, BlockPistonHead block, int x, int y, int z, boolean flag) {
+    public void renderPistonHeadNoCulling(Tessellator tessellator, Block<BlockLogicPistonHead> block, int x, int y, int z, boolean flag) {
         renderBlocks.renderAllFaces = true;
         renderPistonHead(tessellator, block, x, y, z, flag);
         renderBlocks.renderAllFaces = false;
@@ -43,9 +43,9 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockPistonHead> {
     public void setFaceTextureOverride(@Nullable IconCoordinate faceTexture){
         faceTextureOverride = faceTexture;
     }
-    protected boolean renderPistonHead(Tessellator tessellator, BlockPistonHead block, int x, int y, int z, boolean flag) {
+    protected boolean renderPistonHead(Tessellator tessellator, Block<BlockLogicPistonHead> block, int x, int y, int z, boolean flag) {
         int metadata = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
-        Direction direction = BlockPistonHead.getDirectionFromMeta(metadata);
+        Direction direction = BlockLogicPistonHead.getDirectionFromMeta(metadata);
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
         	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
@@ -185,19 +185,19 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockPistonHead> {
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
-        Direction direction = BlockPistonHead.getDirectionFromMeta(data);
+        Direction direction = BlockLogicPistonHead.getDirectionFromMeta(data);
         if(side.getDirection() == direction)
         {
             if(faceTextureOverride != null)
             {
                 return faceTextureOverride;
             }
-            switch (BlockPistonHead.getPistonType(data)) {
-                case BlockPistonHead.TYPE_NORMAL:
+            switch (BlockLogicPistonHead.getPistonType(data)) {
+                case BlockLogicPistonHead.TYPE_NORMAL:
                     return pistonDry;
-                case BlockPistonHead.TYPE_STICKY:
+                case BlockLogicPistonHead.TYPE_STICKY:
                     return pistonSticky;
-                case BlockPistonHead.TYPE_STEEL:
+                case BlockLogicPistonHead.TYPE_STEEL:
                     return pistonSteel;
             }
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPlanksPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPlanksPainted.java
index c8669f53f..51d5e8862 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPlanksPainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPlanksPainted.java
@@ -3,10 +3,11 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelPlanksPainted<T extends Block> extends BlockModelStandard<T> {
+public class BlockModelPlanksPainted<T extends BlockLogic> extends BlockModelStandard<T> {
     public static final IconCoordinate[] texCoords = new IconCoordinate[DyeColor.COLOR_AMOUNT];
 
     static {
@@ -15,7 +16,7 @@ public class BlockModelPlanksPainted<T extends Block> extends BlockModelStandard
         }
     }
 
-    public BlockModelPlanksPainted(Block block) {
+    public BlockModelPlanksPainted(Block<T> block) {
         super(block);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPortal.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPortal.java
index 867522d09..7d14b6bd2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPortal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPortal.java
@@ -3,15 +3,15 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockPortal;
+import net.minecraft.core.block.BlockLogicPortal;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelPortal<T extends BlockPortal> extends BlockModelTransparent<T> {
+public class BlockModelPortal<T extends BlockLogicPortal> extends BlockModelTransparent<T> {
     protected IconCoordinate[] colors = new IconCoordinate[16];
-    public BlockModelPortal(Block block, String rootTexKey) {
+    public BlockModelPortal(Block<T> block, String rootTexKey) {
         super(block, false);
         for (DyeColor color : DyeColor.values()) {
             colors[color.blockMeta] = TextureRegistry.getTexture(rootTexKey + color.colorID);
@@ -21,7 +21,7 @@ public class BlockModelPortal<T extends BlockPortal> extends BlockModelTranspare
     @Override
     public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side)
     {
-        if(blockAccess.getBlockId(x, y, z) == block.id)
+        if(blockAccess.getBlockId(x, y, z) == block.id())
         {
             return false;
         }
@@ -30,7 +30,7 @@ public class BlockModelPortal<T extends BlockPortal> extends BlockModelTranspare
 
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
-        return colors[block.fromMetadata(data).blockMeta];
+        return colors[block.getLogic().fromMetadata(data).blockMeta];
     }
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java
index b0aa68bcc..254d2dc36 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java
@@ -6,13 +6,14 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockModelPumice<T extends Block> extends BlockModelStandard<T> {
+public class BlockModelPumice<T extends BlockLogic> extends BlockModelStandard<T> {
     private boolean lavaFlag = false;
-    public BlockModelPumice(Block block) {
+    public BlockModelPumice(Block<T> block) {
         super(block);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumpkinRedstone.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumpkinRedstone.java
index 575e75c8d..fb63afe6b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumpkinRedstone.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumpkinRedstone.java
@@ -3,12 +3,12 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockPumpkinRedstone;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelPumpkinRedstone extends BlockModelHorizontalRotation<BlockPumpkinRedstone> {
+public class BlockModelPumpkinRedstone<T extends BlockLogic> extends BlockModelHorizontalRotation<T> {
     protected IconCoordinate overlay = TextureRegistry.getTexture("minecraft:block/pumpkin_redstone/front_overlay");
-    public BlockModelPumpkinRedstone(Block block) {
+    public BlockModelPumpkinRedstone(Block<T> block) {
         super(block);
     }
 
